<?php

namespace Swissup\Recaptcha\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\HTTP\PhpEnvironment\RemoteAddress;
use Magento\Store\Model\ScopeInterface;

class IpAllow extends AbstractHelper
{

    const CHECKOUT_RECAPTCHA_ALLOW_LIST_CONFIG_PATH = 'swissup_recaptcha/general/checkout_ip_allowlist';

    /**
     * @var RemoteAddress
     */
    private $remoteAddress;

    /**
     * __construct
     *
     * @param Context $context [description]
     * @param RemoteAddress $remoteAddress
     */
    public function __construct(
        Context $context,
        RemoteAddress $remoteAddress
    ) {
        $this->remoteAddress = $remoteAddress;
        parent::__construct($context);
    }


    /**
     * If true, that client will not be challenged by Recaptcha
     * @return bool
     */
    public function isIpAllowed()
    {
        $allowedIpList = explode("\n", $this->scopeConfig->getValue(self::CHECKOUT_RECAPTCHA_ALLOW_LIST_CONFIG_PATH, ScopeInterface::SCOPE_STORE,
            null));
        if(!empty($allowedIpList))
        {
            $currentIp = $this->getCurrentIp();
            foreach ($allowedIpList as $allowedIp) {
                if ($currentIp == trim($allowedIp))
                    return true;
            }

        }
        return false;
    }

    /**
     * Retrieve User IP
     *
     * @return string
     */
    public function getCurrentIp()
    {
        return $this->remoteAddress->getRemoteAddress();
    }

}
